From 121cca4a06788281738ff79ec376adeb5f1c8eb3 Mon Sep 17 00:00:00 2001
From: Adrian Taylor <adetaylor@chromium.org>
Date: Oct 10 2020 23:01:26 +0000
Subject: [PATCH 1030/2232] Add tests for ExternType.


---

diff --git a/tests/ffi/build.rs b/tests/ffi/build.rs
index e583944..4b2cbdf 100644
--- a/tests/ffi/build.rs
+++ b/tests/ffi/build.rs
@@ -6,7 +6,7 @@ fn main() {
     }
 
     CFG.include_prefix = "tests/ffi";
-    let sources = vec!["lib.rs", "module.rs"];
+    let sources = vec!["lib.rs", "extra.rs", "module.rs"];
     cxx_build::bridges(sources)
         .file("tests.cc")
         .flag_if_supported(cxxbridge_flags::STD)
diff --git a/tests/ffi/extra.rs b/tests/ffi/extra.rs
new file mode 100644
index 0000000..cd6ffe8
--- /dev/null
+++ b/tests/ffi/extra.rs
@@ -0,0 +1,35 @@
+// Separate mod so that &self in the lib.rs mod
+// has an unambiguous receiver.
+// At the moment, the cxx C++ codegen can't convert
+// more than one cxx::bridge mod per file, so that's why
+// we need to put this outside of lib.rs.
+// All of this could go into module.rs instead, but
+// for now its purpose is narrowly scoped for testing
+// aliasing between cxx::bridge mods, so we'll keep it that
+// way and start a new mod here.
+
+// Rustfmt mangles the extern type alias.
+// https://github.com/rust-lang/rustfmt/issues/4159
+#[rustfmt::skip]
+#[cxx::bridge(namespace = tests)]
+pub mod ffi2 {
+
+    impl UniquePtr<D> {}
+    impl UniquePtr<E> {}
+
+    extern "C" {
+        include!("tests/ffi/tests.h");
+
+        type D = crate::other::D;
+        type E = crate::other::E;
+
+        fn c_take_trivial_ptr(d: UniquePtr<D>);
+        fn c_take_trivial_ref(d: &D);
+        fn c_take_trivial(d: D);
+        fn c_take_opaque_ptr(e: UniquePtr<E>);
+        fn c_take_opaque_ref(e: &E);
+        fn c_return_trivial_ptr() -> UniquePtr<D>;
+        fn c_return_trivial() -> D;
+        fn c_return_opaque_ptr() -> UniquePtr<E>;
+    }
+}
\ No newline at end of file
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index 5cfd97b..a0a2a73 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -5,10 +5,37 @@
 )]
 
 pub mod module;
+pub mod extra;
 
 use cxx::{CxxString, CxxVector, UniquePtr};
 use std::fmt::{self, Display};
 
+mod other {
+    use cxx::kind::{Opaque, Trivial};
+    use cxx::{type_id, CxxString, ExternType};
+
+    #[repr(C)]
+    pub struct D {
+        d: u64,
+    }
+
+    #[repr(C)]
+    pub struct E {
+        e: u64,
+        e_str: CxxString,
+    }
+
+    unsafe impl ExternType for D {
+        type Id = type_id!("tests::D");
+        type Kind = Trivial;
+    }
+
+    unsafe impl ExternType for E {
+        type Id = type_id!("tests::E");
+        type Kind = Opaque;
+    }
+}
+
 #[cxx::bridge(namespace = tests)]
 pub mod ffi {
     #[derive(Clone)]
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 3a1a03f..983cf95 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -4,6 +4,8 @@
 #include <iterator>
 #include <numeric>
 #include <stdexcept>
+#include <memory>
+#include <string>
 
 extern "C" void cxx_test_suite_set_correct() noexcept;
 extern "C" tests::R *cxx_test_suite_get_box() noexcept;
@@ -381,6 +383,54 @@ rust::String cOverloadedFunction(rust::Str x) {
   return rust::String(std::string(x));
 }
 
+void c_take_trivial_ptr(std::unique_ptr<D> d) {
+  if (d->d == 30) {
+    cxx_test_suite_set_correct();
+  }
+}
+
+void c_take_trivial_ref(const D& d) {
+  if (d.d == 30) {
+    cxx_test_suite_set_correct();
+  }
+}
+void c_take_trivial(D d) {
+  if (d.d == 30) {
+    cxx_test_suite_set_correct();
+  }
+}
+
+void c_take_opaque_ptr(std::unique_ptr<E> e) {
+  if (e->e == 40) {
+    cxx_test_suite_set_correct();
+  }
+}
+
+void c_take_opaque_ref(const E& e) {
+  if (e.e == 40 && e.e_str == "hello") {
+    cxx_test_suite_set_correct();
+  }
+}
+
+std::unique_ptr<D> c_return_trivial_ptr() {
+  auto d = std::unique_ptr<D>(new D());
+  d->d = 30;
+  return d;
+}
+
+D c_return_trivial() {
+  D d;
+  d.d = 30;
+  return d;
+}
+
+std::unique_ptr<E> c_return_opaque_ptr() {
+  auto e = std::unique_ptr<E>(new E());
+  e->e = 40;
+  e->e_str = std::string("hello");
+  return e;
+}
+
 extern "C" const char *cxx_run_test() noexcept {
 #define STRINGIFY(x) #x
 #define TOSTRING(x) STRINGIFY(x)
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index 9affe7d..b3f547e 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -28,6 +28,15 @@ private:
   std::vector<uint8_t> v;
 };
 
+struct D {
+  uint64_t d;
+};
+
+struct E {
+  uint64_t e;
+  std::string e_str;
+};
+
 enum COwnedEnum {
   CVal1,
   CVal2,
@@ -103,6 +112,15 @@ rust::Vec<uint8_t> c_try_return_rust_vec();
 rust::Vec<rust::String> c_try_return_rust_vec_string();
 const rust::Vec<uint8_t> &c_try_return_ref_rust_vec(const C &c);
 
+void c_take_trivial_ptr(std::unique_ptr<D> d);
+void c_take_trivial_ref(const D& d);
+void c_take_trivial(D d);
+void c_take_opaque_ptr(std::unique_ptr<E> e);
+void c_take_opaque_ref(const E& e);
+std::unique_ptr<D> c_return_trivial_ptr();
+D c_return_trivial();
+std::unique_ptr<E> c_return_opaque_ptr();
+
 rust::String cOverloadedFunction(int32_t x);
 rust::String cOverloadedFunction(rust::Str x);
 
diff --git a/tests/test.rs b/tests/test.rs
index ea29e62..9828429 100644
--- a/tests/test.rs
+++ b/tests/test.rs
@@ -1,4 +1,5 @@
 use cxx_test_suite::ffi;
+use cxx_test_suite::extra::ffi2;
 use std::cell::Cell;
 use std::ffi::CStr;
 
@@ -190,3 +191,19 @@ fn test_rust_name_attribute() {
     assert_eq!("2020", unique_ptr.i32_overloaded_method(2020));
     assert_eq!("2020", unique_ptr.str_overloaded_method("2020"));
 }
+
+#[test]
+fn test_extern_trivial() {
+    let d = ffi2::c_return_trivial();
+    check!(ffi2::c_take_trivial_ref(&d));
+    check!(ffi2::c_take_trivial(d));
+    let d = ffi2::c_return_trivial_ptr();
+    check!(ffi2::c_take_trivial_ptr(d));
+}
+
+#[test]
+fn test_extern_opaque() {
+    let e = ffi2::c_return_opaque_ptr();
+    check!(ffi2::c_take_opaque_ref(e.as_ref().unwrap()));
+    check!(ffi2::c_take_opaque_ptr(e));
+}

